#!/usr/bin/perl

use strict;
use warnings;

BEGIN {
    if ($0 =~ m|^(.*)/[^/]+$|) {
        push(@INC, $1);
    }
}

use SOAP::Lite +trace => 'debug';
use MIME::Base64;
use HPSMSOAP;

my $site = 'http://bp4smdemo.hpsweducation.com:13080/SM/7';
my $user = 'falcon';
my $password = 'orange perfection';
my $auth = encode_base64("$user:$password", '');

my %ticket = (
    'int' => 'Interaction',
    'inc' => 'Incident',
    'ch' => 'Change'
    );
my %wsdl = (
    'int' => 'ServiceDesk',
    'inc' => 'IncidentManagement',
    'ch' => 'ChangeManagement'
    );
my %keyname = (
    'int' => 'CallID',
    'inc' => 'IncidentID',
    'ch' => 'ChangeID'
    );

die "Usage: perl create.pl kind\n\twhere kind is int, inc, or ch\n"
    unless ($ARGV[0] =~ m/^(int|inc|ch)$/);

my $ticket = $ticket{$ARGV[0]};
my $wsdl = $wsdl{$ARGV[0]};
my $keyname = $keyname{$ARGV[0]};

my $soap = SOAP::Lite->new(
    proxy => "$site/ws",
    service => "$site/$wsdl.wsdl",
    default_ns => $site);
$soap->transport->http_request->header('Authorization' => "Basic $auth");
$soap->on_action(sub { '"Create"'; } );

my $keys = SOAP::Data->name('keys' => '')->type('');
my $instance = SOAP::Data->name('instance' => '')->type('');
my $model = SOAP::Data->name('model' => \SOAP::Data->value($keys, $instance));
my $som = $soap->call("Create$ticket", $model);

soapfault($som);
soapstatus($som);
soapdata($som, "//Create$ticket" . "Response/messages", 1);
soapdata($som, "//Create$ticket" . "Response/model", 0);
print "result is "
    . $som->valueof("//Create$ticket" . "Response/model/keys/$keyname")
    . "\n";
